Name

    SGIX_fog_offset

Name Strings

    GL_SGIX_fog_offset

Version

    $Date: 1996/04/01 23:22:48 $ $Revision: 1.1 $

Number

	65

Dependencies

	XXX

Overview

    This extension allows to make objects look brighter in the foggy 
    environment. GL_FOG_OFFSET_VALUE_SGIX parameter specifies point 
    coordinates in eye-space and offset amount toward viewpoint.
    Once fog offset is specified and enabled using GL_FOG_OFFSET_SGIX 
    parameter, it will be subtracted from the depth value (to make objects 
    closer to the viewer) right before fog calculation. As a result objects 
    look less foggy.
    

New Procedures and Functions

    None

New Tokens

    Accepted by the <cap> parameter of Enable, Disable, and IsEnabled

	GL_FOG_OFFSET_SGIX

    Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, 
    and GetDoublev, and by the <pname> parameter of Fogiv and Fogfv:

	GL_FOG_OFFSET_VALUE_SGIX

Additions to Chapter 2 of the 1.0 Specification (OpenGL Operation)

    None

Additions to Chapter 3 of the 1.0 Specification (Rasterization)


    3.9 Fog
    When fog is enabled it is equally applied to the all objects in the scene.
    This can create unrealistic effects for the objects with a high brightness 
    (light sources for instance). To make such objects look brighter fog 
    offset may be subtracted from the eye-distance before it is used for the 
    fog calculation. Fog offset value may be specified by calling the glFog 
    function with GL_FOG_OFFSET_VALUE_SGIX <pname> and four <params>.
    First three parameters are point coordinates in the eye-space and fourth 
    parameter is an offset distance in the eye-space. If final distance is
    negative as a result of offset subtraction it is clamped to 0.
    In the case of perspective projection fog offset will be properly 
    calculated for the objects surrounding the given point. If objects are too
    far away from the given point fog offset value should be redefined again. 
    In the case of ortho projection fog offset value is correct for any object 
    location.
    Fog offset can be enabled/disabled by calling glEnable/glDisable functions 
    with GL_FOG_OFFSET_SGIX parameter.


Additions to Chapter 4 of the 1.0 Specification (Per-Fragment Operations
and the Framebuffer)

    None

Additions to Chapter 5 of the 1.0 Specification (Special Functions)

    None

Additions to Chapter 6 of the 1.0 Specification (State and State Requests)

    The value of the fog offset is queried by calling GetBooleanv, GetIntegerv, 
    GetFloatv, and GetDoublev with <pname> set to GL_FOG_OFFSET_VALUE_SGIX.
    Fog offset enable/disable state is checked by calling glIsEnable function 
    with GL_FOG_OFFSET_SGIX parameter.

Additions to the GLX Specification

    None

Errors

    None

New State

    Get Value			Get Command		Type		Initial Value	Attribute
    ---------			-----------		----		-------------	---------
    FOG_OFFSET_SGIX		IsEnabled		B		FALSE		fog
    FOG_OFFSET_VALUE_SGIX	GetFloatv		4 * R		(0, 0, 0, 0)	fog


New Implementation Dependent State

    None
