Name

    SGIX_texture_add_env

Name Strings

    GL_SGIX_texture_add_env

Version

    $Date: 1996/04/01 23:23:23 $ $Revision: 1.1 $

Number

    69

Dependencies

    None

Overview

    Two new texture environment functions are supported with the following 
    equations: 
	1. add          Cv = Cf + Cc * Ct
	2. add signed   Cv = Cf + Cc * (Ct - 0.5)
    New functions may be  specified by calling glTexEnv with one of the following
    tokens: GL_ADD_SGIX or GL_ADD_GISNED_SGIX.
    

New Procedures and Functions

    None

New Tokens

    Accepted by the <params> parameter of TexEnvf, TexEnvi, TexEnvfv, and
    TexEnvfi when the <pname> parameter value is
    GL_TEXTURE_ENV_MODE

	GL_ADD_SGIX                      0x80BE
	GL_ADD_SIGNED_SGIX               0x80BF


Additions to Chapter 2 of the GL Specification (OpenGL Operation)

	None

Additions to Chapter 3 of the GL Specification (Rasterization)


				Texture Environment
				-------------------

	Base Texture Format	REPLACE  MODULATE  BLEND  DECAL  ADD                    ADD_SIGNED
	-------------------	-------  --------  -----  -----  ---                    ----------

	LUMINANCE		 ...      ...       ...    ...   Rv = Rf + Rc * Rt	Rv = Rf + Rc * (Rt - 0.5)
				 ...      ...       ...    ...   Gv = Gf + Gc * Gt	Gv = Gf + Gc * (Gt - 0.5)
				 ...      ...       ...    ...   Bv = Bf + Bc * Bt	Bv = Bf + Bc * (Bt - 0.5)
				 ...      ...       ...    ...   Av = Af		Av = Af

	ALPHA			 ...      ...       ...    ...   Rv = Rf		Rv = Rf
				 ...      ...       ...    ...   Gv = Gf		Gv = Gf
				 ...      ...       ...    ...   Bv = Bf		Bv = Bf
				 ...      ...       ...    ...   Av = Af * At		Av = Af * At

	INTENSITY_EXT		 ...      ...       ...    ...   Rv = Rf + Rc * Rt      Rv = Rf + Rc * (Rt - 0.5)
				 ...      ...       ...    ...   Gv = Gf + Gc * Gt      Gv = Gf + Gc * (Gt - 0.5)
				 ...      ...       ...    ...   Bv = Bf + Bc * Bt      Bv = Bf + Bc * (Bt - 0.5)
				 ...      ...       ...    ...   Av = Af + Ac * At      Av = Af + Ac * (At - 0.5)

	LUMINANCE_ALPHA		 ...      ...       ...    ...   Rv = Rf + Rc * Rt      Rv = Rf + Rc * (Rt - 0.5)
				 ...      ...       ...    ...   Gv = Gf + Gc * Gt      Gv = Gf + Gc * (Gt - 0.5)
				 ...      ...       ...    ...   Bv = Bf + Bc * Bt      Bv = Bf + Bc * (Bt - 0.5)
				 ...      ...       ...    ...   Av = Af * At           Av = Af * At

	RGB			 ...      ...       ...    ...   Rv = Rf + Rc * Rt      Rv = Rf + Rc * (Rt - 0.5)
				 ...      ...       ...    ...   Gv = Gf + Gc * Gt      Gv = Gf + Gc * (Gt - 0.5)
				 ...      ...       ...    ...   Bv = Bf + Bc * Bt      Bv = Bf + Bc * (Bt - 0.5)
				 ...      ...       ...    ...   Av = Af		Av = Af

	RGBA			 ...      ...       ...    ...   Rv = Rf + Rc * Rt      Rv = Rf + Rc * (Rt - 0.5)
				 ...      ...       ...    ...   Gv = Gf + Gc * Gt      Gv = Gf + Gc * (Gt - 0.5)
				 ...      ...       ...    ...   Bv = Bf + Bc * Bt      Bv = Bf + Bc * (Bt - 0.5)
				 ...      ...       ...    ...   Av = Af * At		Av = Af * At

	Table 3.8: Texture functions.


Additions to Chapter 4 of the GL Specification (Per-Fragment Operations
and the Framebuffer)

    None

Additions to Chapter 5 of the GL Specification (Special Functions)

    None

Additions to Chapter 6 of the GL Specification (State and State Requests)

    None

Additions to the GLX Specification

    None

GLX Protocol

    None

Errors

    None

New State

    None

New Implementation Dependent State

    None
